			.area CODE2

			.include "arch.inc"
			.include "arch-sio.inc"

int_main::		push	AF
			; swap to int stack
			ld	(ARCH_Z_INT_HL_SAVE), HL
			ld 	HL, #0
			add	HL, SP
			ld	(ARCH_Z_INT_SP_SAVE), HL
			ld	HL, (ARCH_Z_INT_HL_SAVE)
			ld	SP, #ARCH_MEM_INTSTACK
			push	BC
			push	DE
			push	HL
			push	IX
			push	IY

			call	sio_int_check

			pop	IY
			pop	IX
			pop	HL
			pop	DE
			pop	BC
			ld	SP, (ARCH_Z_INT_SP_SAVE)
			pop	AF
			ei
			reti


int_init::		
			; set up interrupt vector at 0H0038

			ld	A, #0HC3
			ld	(0H0038), A	; store jump address

			ld	HL, #int_main
			ld	(0H0039), HL

			im	1			
			ei
			ret
